Debian Bug report logs - #423707
dh-make: --host and --build does not conform to the docs in autotools-dev

version graph

Package: dh-make; Maintainer for dh-make is Craig Small <csmall@debian.org>; Source for dh-make is src:dh-make.

Reported by: Sune Vuorela <reportbug@pusling.com>

Date: Mon, 14 May 2007 00:06:02 UTC

Severity: normal

Tags: patch

Found in version dh-make/0.43

Fixed in version dh-make/0.45

Done: Craig Small <csmall@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#423707; Package dh-make. Full text and rfc822 format available.

Acknowledgement sent to Sune Vuorela <reportbug@pusling.com>:
New Bug report received and forwarded. Copy sent to Craig Small <csmall@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Sune Vuorela <reportbug@pusling.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dh-make: --host and --build does not conform to the docs in autotools-dev
Date: Mon, 14 May 2007 02:05:22 +0200
Package: dh-make
Version: 0.43
Severity: normal


Hi!

The docs in autotools-dev package (README.Debian.gz) says the following
about --host and --build: (with line numbers)

185 export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
186 export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
187
188 # FOR AUTOCONF 2.52 AND NEWER ONLY
189 ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
190   confflags += --build $(DEB_HOST_GNU_TYPE)
191 else
192   confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
193 endif

dh_make templates gives me:

 15 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 16 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 36         ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"


It would be nice if these fitted to each others


/Sune

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable'), (200, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 2.6.20-1-vserver-k7 (SMP w/1 CPU core)
Locale: LANG=en_GB, LC_CTYPE=en_GB (charmap=ISO-8859-1)
Shell: /bin/sh linked to /bin/dash

Versions of packages dh-make depends on:
ii  debhelper                     5.0.49     helper programs for debian/rules
ii  dpkg-dev                      1.14.2     package building tools for Debian
ii  make                          3.81-3     The GNU version of the "make" util
ii  perl                          5.8.8-7    Larry Wall's Practical Extraction 

dh-make recommends no packages.

-- debconf-show failed



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#423707; Package dh-make. Full text and rfc822 format available.

Acknowledgement sent to Craig Small <csmall@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #10 received at 423707@bugs.debian.org (full text, mbox):

From: Craig Small <csmall@debian.org>
To: Sune Vuorela <reportbug@pusling.com>, 423707@bugs.debian.org
Subject: Re: Bug#423707: dh-make: --host and --build does not conform to the docs in autotools-dev
Date: Tue, 9 Oct 2007 09:10:40 +1000
On Mon, May 14, 2007 at 02:05:22AM +0200, Sune Vuorela wrote:
> It would be nice if these fitted to each others
Isn't the only difference the fact that the document conditionally sets
the --host flag

I'm not sure if that makes a big difference, though I could easily be
wrong.

 - Craig
-- 
Craig Small      GnuPG:1C1B D893 1418 2AF4 45EE  95CB C76C E5AC 12CA DFA5
http://www.enc.com.au/                             csmall at : enc.com.au
http://www.debian.org/          Debian GNU/Linux, software should be Free 




Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#423707; Package dh-make. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. Full text and rfc822 format available.

Message #15 received at 423707@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 423707@bugs.debian.org
Subject: patch available
Date: Sat, 17 Nov 2007 18:06:49 +0000
[Message part 1 (text/plain, inline)]
> > It would be nice if these fitted to each others

It would also be correct. This came to my attention after a discussion
on debian-mentors.

> Isn't the only difference the fact that the document conditionally 
> sets the --host flag

No, it can cause problems because the "native" build tries to use a
cross-compiler. Instead of running gcc, the build runs
i486-linux-gnu-gcc or powerpc-linux-gnu-gcc. Equally, omitting --build
entirely is also incorrect to ensure the correct build is specified.

> I'm not sure if that makes a big difference, though I could easily be
> wrong.

IMHO, yes this is wrong and in line with the other cross-building
support bugs,
(http://lists.debian.org/debian-devel/2007/11/msg00116.html) I have
created a patch that correctly handles the --build and --host
statements within dh_make.

Therefore, as discussed on debian-devel, please fix dh-make to
implement the correct cross building support in new packages.

-- 

Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/
[crossbuild.diff (text/x-diff, attachment)]
[Message part 3 (application/pgp-signature, inline)]

Tags added: patch Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sat, 17 Nov 2007 18:21:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Craig Small <csmall@debian.org>:
Bug#423707; Package dh-make. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Craig Small <csmall@debian.org>. Full text and rfc822 format available.

Message #22 received at 423707@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 423707@bugs.debian.org
Subject: Changes for $(MAKE) too
Date: Sat, 17 Nov 2007 18:31:43 +0000
[Message part 1 (text/plain, inline)]
Not sure how to patch this one, but packages that do not
use ./configure also need to have cross build support. Typically,
Emdebian recommends:

DEB_HOST_GNU_TYPE  ?=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS=CC=$(DEB_HOST_GNU_TYPE)-gcc CXX=$(DEB_HOST_GNU_TYPE)-g++
else
CROSS=
endif

Then, for each $(MAKE) ... line, convert to:
$(MAKE) $(CROSS) ...

http://wiki.debian.org/EmdebianGuide

That change may need some wider changes in dh_make.

Note that in any package that needs to use CC_FOR_BUILD or otherwise
build internal tools using the native compiler, $(CROSS) should be
omitted for that directory. These packages are unusual - and some
handle CC_FOR_BUILD internally - but the situation may need some comment
in the dh_make manpage. Other packages also need to add CXX=
$(DEB_HOST_GNU_TYPE)-g++ to the $(CROSS) variable if they use C ++ or
combine C ++ code with C code, hence the addition above.

Feel free to link to the Emdebian wiki pages from the dh_make manpage
or get back to me (or the debian-embedded m-l) for any other cross
building queries.

-- 

Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/
[Message part 2 (application/pgp-signature, inline)]

Tags added: pending Request was from Craig Small <csmall@debian.org> to control@bugs.debian.org. (Sun, 20 Jan 2008 23:27:05 GMT) Full text and rfc822 format available.

Reply sent to Craig Small <csmall@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Sune Vuorela <reportbug@pusling.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #29 received at 423707-close@bugs.debian.org (full text, mbox):

From: Craig Small <csmall@debian.org>
To: 423707-close@bugs.debian.org
Subject: Bug#423707: fixed in dh-make 0.45
Date: Fri, 09 May 2008 13:02:02 +0000
Source: dh-make
Source-Version: 0.45

We believe that the bug you reported is fixed in the latest version of
dh-make, which is due to be installed in the Debian FTP archive:

dh-make_0.45.dsc
  to pool/main/d/dh-make/dh-make_0.45.dsc
dh-make_0.45.tar.gz
  to pool/main/d/dh-make/dh-make_0.45.tar.gz
dh-make_0.45_all.deb
  to pool/main/d/dh-make/dh-make_0.45_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 423707@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Craig Small <csmall@debian.org> (supplier of updated dh-make package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Fri, 09 May 2008 22:41:38 +1000
Source: dh-make
Binary: dh-make
Architecture: source all
Version: 0.45
Distribution: unstable
Urgency: low
Maintainer: Craig Small <csmall@debian.org>
Changed-By: Craig Small <csmall@debian.org>
Description: 
 dh-make    - tool that converts source archives into Debian package source
Closes: 352017 383495 409694 422203 423707 424953 428228 431316 431316 432667 445678 445766 445768 445773 447752 448854 448854 453896 453896 464948 468774
Changes: 
 dh-make (0.45) unstable; urgency=low
 .
   [ Craig Small ]
   * Finally (I hope) fixed manpage.xml.ex Closes: #383495
   * lib control uses binary:Version Closes: #428228
   * Added Homepage: tag to control file Closes: #445678
   * CMakeList.txt is not a document Closes: #422203
   * Offering use of dpatch. Closes: #409694
   * init.d.lsb fixes from JFS Closes: #445766, #445768, #445773
   * Crosscompile patch added Closes: #423707
   * init.d.lsb stop_server() errcode fixed Closes: #448854
   * Fixed init.d.ex running Closes: #453896
   * Typo in dh_make org -> orig Closes: #431316
   * Changed package-default.ex to package.default.ex Closes: #424953
   * Updated to debhelper version 6 in package and templates
   * Added examples to man page Closes: #352017
   * Fixed distclean target Closes: #432667
   [ Tobias Toedter ]
   * Fix typo in dh_make message. Closes: #431316
   * Fix typo in init.d.lsb, thanks to Yauhen Kharuzhy. Closes: #448854
   * Correct errors in init.d, thanks to Marcos Talau. Closes: #453896
   * Ignore a missing Makefile in clean targets, but not other errors.
     Thanks to Sune Vuorela. Closes: #468774
   * Update to Standards-Version 3.7.3 in generated templates, thanks
     to Nelson A. de Oliveira. Closes: #464948
   * Use untranslated dates for manpages. Closes: #447752
Files: 
 29e767bf2b410e15b275890c8c716af7 482 devel optional dh-make_0.45.dsc
 8882b7a537928ddb8e798ede0a306e40 37978 devel optional dh-make_0.45.tar.gz
 265b410142c174ea80e51280c7e3728c 40634 devel optional dh-make_0.45_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFIJEavx2zlrBLK36URAhQmAKCGYAG0DV9r4tTuZy236ZGke19R2wCffzYV
zWIuNw7CZUQSYSyru+xJTnw=
=He56
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 18 Jun 2008 07:27:12 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 04:18:16 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.